# coding: utf-8

"""
    Alfresco Content Services REST API

    **Core API**  Provides access to the core features of Alfresco Content Services.   # noqa: E501

    OpenAPI spec version: 1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from alfresco_core_api_client.configuration import Configuration


class ChildAssociation(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'child_id': 'str',
        'assoc_type': 'str'
    }

    attribute_map = {
        'child_id': 'childId',
        'assoc_type': 'assocType'
    }

    def __init__(self, child_id=None, assoc_type=None, _configuration=None):  # noqa: E501
        """ChildAssociation - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._child_id = None
        self._assoc_type = None
        self.discriminator = None

        self.child_id = child_id
        self.assoc_type = assoc_type

    @property
    def child_id(self):
        """Gets the child_id of this ChildAssociation.  # noqa: E501


        :return: The child_id of this ChildAssociation.  # noqa: E501
        :rtype: str
        """
        return self._child_id

    @child_id.setter
    def child_id(self, child_id):
        """Sets the child_id of this ChildAssociation.


        :param child_id: The child_id of this ChildAssociation.  # noqa: E501
        :type: str
        """
        if self._configuration.client_side_validation and child_id is None:
            raise ValueError("Invalid value for `child_id`, must not be `None`")  # noqa: E501

        self._child_id = child_id

    @property
    def assoc_type(self):
        """Gets the assoc_type of this ChildAssociation.  # noqa: E501


        :return: The assoc_type of this ChildAssociation.  # noqa: E501
        :rtype: str
        """
        return self._assoc_type

    @assoc_type.setter
    def assoc_type(self, assoc_type):
        """Sets the assoc_type of this ChildAssociation.


        :param assoc_type: The assoc_type of this ChildAssociation.  # noqa: E501
        :type: str
        """
        if self._configuration.client_side_validation and assoc_type is None:
            raise ValueError("Invalid value for `assoc_type`, must not be `None`")  # noqa: E501

        self._assoc_type = assoc_type

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(ChildAssociation, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ChildAssociation):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, ChildAssociation):
            return True

        return self.to_dict() != other.to_dict()
